
#include "objects.h"

SuperHyperboloid_1( xaxis, yaxis, zaxis, length, center, depth,
                    n1, n2, clockwise, primitive )
float xaxis, yaxis, zaxis;
float length;
Point center;
int depth;
int n1, n2;
char clockwise;
int primitive;
{
    int i, j;        /* i/phi    j/theta */
    float is, js;
    float phi, theta, step;
    float fphiSize, fthetaSize;
    int phiSize, thetaSize;
    Point hyperboloid[130][260];
    FILE *fp;
    extern char *filename;

    fp = fopen( filename, "w" );

    step = (float)(M_PI / pow( (double)2, (double)depth ));
    fphiSize = (M_PI / step) + 1.;
    fthetaSize = (2 * M_PI / step) + 1.;
    phiSize = (int)fphiSize;
    thetaSize = (int)fthetaSize;

    for( i = 0; i < phiSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
            double cos;
            is = -(M_PI/2.) + i * step;
            js = -M_PI + j * step;
            cos = cos( is );
            if( NEAR_ZERO( cos ) ) cos = length;
            hyperboloid[i][j].x = xaxis / pow( cos, (double)n1 ) *
                                          pow( cos( js ), (double)n2 ) +
                                          center.x;
            hyperboloid[i][j].y = yaxis / pow( cos, (double)n1 ) *
                                          pow( sin( js ), (double)n2 ) +
                                          center.y;
            hyperboloid[i][j].z = zaxis / pow( cos, (double)n1 ) *
                                          pow( sin( is ), (double)n1 ) +
                                          center.z;
        }
    }

    /* Print the Coordinates of the points */
    fprintf( fp, "%d\n", phiSize * thetaSize );
    for( i = 0; i < phiSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
            fprintf( fp, "%f %f %f\n", hyperboloid[i][j].x, hyperboloid[i][j].y,
                                       hyperboloid[i][j].z );
        }
    }

    /* Print the Conectivity data of the points */
    fprintf( fp, "%d\n", (phiSize-1) * (thetaSize-1) );
    if( clockwise ) {
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < phiSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1,     j*thetaSize+(i+1)+1,
                       (j+1)*thetaSize+i+1, (j+1)*thetaSize+(i+1)+1 );
            }
        }
    }
    else {    /* counterClockwise */
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < phiSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1, (j+1)*thetaSize+i+1,
                   (j+1)*thetaSize+(i+1)+1, j*thetaSize+(i+1)+1 );
            }
        }
    }
}
